// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// Job is an autogenerated mock type for the Job type
type Job struct {
	mock.Mock
}

// ClaimJob provides a mock function with given fields: ctx, input
func (_m *Job) ClaimJob(ctx context.Context, input *types.ClaimJobInput) (*types.ClaimJobResponse, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ClaimJobResponse
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.ClaimJobInput) (*types.ClaimJobResponse, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.ClaimJobInput) *types.ClaimJobResponse); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ClaimJobResponse)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.ClaimJobInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetJob provides a mock function with given fields: ctx, input
func (_m *Job) GetJob(ctx context.Context, input *types.GetJobInput) (*types.Job, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Job
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetJobInput) (*types.Job, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetJobInput) *types.Job); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Job)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetJobInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetJobLogs provides a mock function with given fields: ctx, input
func (_m *Job) GetJobLogs(ctx context.Context, input *types.GetJobLogsInput) (*types.JobLogs, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.JobLogs
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetJobLogsInput) (*types.JobLogs, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetJobLogsInput) *types.JobLogs); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.JobLogs)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetJobLogsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SaveJobLogs provides a mock function with given fields: ctx, input
func (_m *Job) SaveJobLogs(ctx context.Context, input *types.SaveJobLogsInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.SaveJobLogsInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// SubscribeToJobCancellationEvent provides a mock function with given fields: ctx, input
func (_m *Job) SubscribeToJobCancellationEvent(ctx context.Context, input *types.JobCancellationEventSubscriptionInput) (<-chan *types.CancellationEvent, error) {
	ret := _m.Called(ctx, input)

	var r0 <-chan *types.CancellationEvent
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.JobCancellationEventSubscriptionInput) (<-chan *types.CancellationEvent, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.JobCancellationEventSubscriptionInput) <-chan *types.CancellationEvent); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(<-chan *types.CancellationEvent)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.JobCancellationEventSubscriptionInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SubscribeToJobLogs provides a mock function with given fields: ctx, input
func (_m *Job) SubscribeToJobLogs(ctx context.Context, input *types.JobLogsSubscriptionInput) (<-chan *types.JobLogsEvent, error) {
	ret := _m.Called(ctx, input)

	var r0 <-chan *types.JobLogsEvent
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.JobLogsSubscriptionInput) (<-chan *types.JobLogsEvent, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.JobLogsSubscriptionInput) <-chan *types.JobLogsEvent); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(<-chan *types.JobLogsEvent)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.JobLogsSubscriptionInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewJob interface {
	mock.TestingT
	Cleanup(func())
}

// NewJob creates a new instance of Job. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewJob(t mockConstructorTestingTNewJob) *Job {
	mock := &Job{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
